<i18n>
{
  "fr": {
    "title": "Les Missions",
    "label-1": "Missions valides",
    "label-2": "Option « motif »",
    "label-3": "Option « statut »",
    "label-4": "Synthèse du fichier",
    "label-5": "Synthèse Globale",
    "error-msg-1": "Format de fichier non pris en charge.",
    "error-msg-2": "La limite du nombre de requêtes sur la base geonames est atteinte, veuillez attendre 1 heure avant de téléverser à nouveau votre fichier de missions.",
    "error-msg-3": "Fichier déjà téléversé",
    "error-msg-4": "Un fichier portant le même nom a déjà été téléversé.",
    "error-msg-5": "Suppression",
    "error-msg-6": "Des missions ne sont pas validées, continuer va entraîner leur suppression. <br /> Êtes vous sûr de vouloir continuer?",
    "error-msg-7": "Les missions téléversées depuis le fichier",
    "error-msg-8": "vont être supprimées. <br />Êtes vous sûr de vouloir continuer?",
    "error-msg-9": "Are you sure you want to delete all the trips data?",
    "error-msg-10": "Fichier invalide ",
    "error-msg-csv-separator": "Impossible de détecter le séparateur de colonne. Celui-ci doit être des tabulations, des virgules, ou des points-virgules.",
    "error-msg-csv-missing": "La colonne '{name}' est manquante.",
    "error-msg-csv-geslabsep": "Pour le format GESLAB, seuls les tabulations sont acceptées comme séparateur de colonne.",
    "error-msg-csv-divers": "Mode de déplacement « Divers » non pris en compte.",
    "error-msg-csv-passager": "Mode de déplacement « Passager » non pris en compte.",
    "error-msg-csv-admin": "Mode de déplacement « Véhicule administratif » non pris en compte.",
    "error-msg-csv-unknown": "Modes de déplacement « {transportation} » non reconnus.",
    "save-msg": "Les informations de déplacements professionnels ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "info-1": "Définissez l'ensemble des missions financées sur crédits du laboratoire en",
    "info-1b": "toutes tutelles confondues",
    "info-2": "Une mission est ici définie par un déplacement professionnel n'utilisant pas les véhicules saisis dans l'onglet spécifique de l’outil.",
    "info-3": "Afin d'éviter les doubles comptages, ne compter que les <strong>déplacements professionnels financés sur crédits du laboratoire</strong>.<br /> Donc, si une personne de votre laboratoire s’est déplacée sur invitation, avec prise en charge de ses frais, ses émissions ne sont pas rattachées à votre laboratoire. Et inversement, si votre laboratoire organise un évènement en prenant en charge les déplacements, toutes les émissions de ces personnes extérieures doivent être imputées à votre laboratoire.",
    "info-4": "Les émissions des missions sont évaluées à l'aide d'un ou plusieurs",
    "info-5": "fichiers de missions",
    "info-6": "que vous pouvez téléverser. Chaque fichier doit être encodé en utf8 et doit contenir les colonnes comme présenté dans ce",
    "info-7": "fichier exemple",
    "info-8": "Quand vous ne disposez d'aucune information sur les escales du déplacement, saisissez seulement la ville de départ et la ville d'arrivée. Les distances des déplacements internes à une ville sont estimées à 0 du fait de l’absence de précisions sur les localisations dans la ville.",
    "info-9": "Lorsque des informations manquent ou sont erronées pour certaines missions dans un fichier téléversé, le statut <em>non valide</em> apparaît. En cliquant sur <i class='sui sui-pencil' style='font-size: 16px;'></i>, vous pouvez modifier la saisie de la mission concernée. Si aucune modification n’est opérée, la mission demeurera non validée et sera supprimée du calcul des émissions de GES.",
    "info-10": "Formats des fichiers de missions",
    "info-11": "Téléverser un fichier (.tsv)",
    "info-12": "Ajouter une mission",
    "info-13": "Modifier une mission",
    "info-14": "Définissez les villes de départ et de destination ainsi que le mode de transport utilisé lors de cette mission. Le motif du déplacement ainsi que le statut de l'agent sont optionnels.",
    "tooltip-1": "Supprimer les données courantes",
    "tooltip-2": "Télécharger les données au format GES 1point5 avec les émissions"
  },
  "en": {
    "title": "Business travel",
    "label-1": "Valid trips",
    "label-2": "« Purpose » option",
    "label-3": "« Position » option",
    "label-4": "File overview",
    "label-5": "Overview",
    "error-msg-1": "Incompatible file format.",
    "error-msg-2": "The maximum number of requests on geonames database has been reached, please wait for an hour to upload your business travel file again.",
    "error-msg-3": "File already uploaded",
    "error-msg-4": "A file with the same name has already been uploaded.",
    "error-msg-5": "Delete",
    "error-msg-6": "Some trips data are not valid. If you continue to proceed, they will be deleted. <br />Are you sure you want to proceed?",
    "error-msg-7": "The trips data uploaded from the file",
    "error-msg-8": "will be deleted. <br />Are you sure you want to proceed?",
    "error-msg-9": "The trips data stored in the database will be deleted. Are you sure you want to proceed?",
    "error-msg-10": "Invalid file",
    "error-msg-csv-separator": "Cannot detect column's separator. Must be either tabs, commas, or semicolons.",
    "error-msg-csv-missing": "Cannot find the column '{name}'.",
    "error-msg-csv-geslabsep": "With the GESLAB format, only tabs are accepted as column separators.",
    "error-msg-csv-divers": "Unsupported travel mode « Divers ».",
    "error-msg-csv-passager": "Unsupported travel mode « Passager ».",
    "error-msg-csv-admin": "Unsupported travel mode « Véhicule administratif ».",
    "error-msg-csv-unknown": "Unknown travel mode « {transportation} ».",
    "save-msg": "The data relating to business travel have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "info-1": "Enter all the business trips that were paid by your laboratory in ",
    "info-1b": "all supervisory included",
    "info-2": "A business trip is defined as a professional trip that did not use any vehicle entered in the specific tab « Vehicles » of the tool",
    "info-3": "In order to avoid double counting, please only enter the <strong>business trips that were paid for by your laboratory</strong>. <br /> Therefore, if a staff member was invited and his/her trip was paid by another organization, your laboratory does not bear the related emissions. Conversely, if your laboratory organizes an event and pays for the trips of the guests, your laboratory is responsible for the emissions generated by these trips.",
    "info-4": "The emissions generated by the business trips are estimated through one or several",
    "info-5": "business trip files",
    "info-6": "that you can upload. Every file must be saved in utf8 format and must contain the columns as presented in this",
    "info-7": "sample file",
    "info-8": "When you have no information about the stopovers of the trip, please only enter the departure city and the arrival city. The travel distances within a city are assumed to be zero due to the absence of distance data for sites within a city.",
    "info-9": "When data are missing or incorrect for some trips in an uploaded file, the status is <em>invalid</em>. When clicking on <i class='sui sui-pencil' style='font-size: 16px;'></i>, you can update the data of the related trip. If no update is made, the trip remains invalid and will be deleted from the GHG emission calculation.",
    "info-10": "Formats of the business trips files",
    "info-11": "Upload a file (.tsv)",
    "info-12": "Add a trip",
    "info-13": "Update a trip",
    "info-14": "Define the departure and arrival cities, as well as the mode of transportation used for this trip. The purpose of the trip and the staff member's position are optional.",
    "tooltip-1": "Delete current data",
    "tooltip-2": "Download data in GES 1point5 format with emissions"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur" />
    <su-service :icon="'train'">
      <template #title>
        {{ $t('title') }}
      </template>
      <p>
        {{ $t('info-1') }} <strong>{{ GHGIYear }}</strong>, {{ $t('info-1b') }}. {{ $t('info-2') }}
        <br />
        <span v-html="$t('info-3')"></span>
        <br /><br />
        {{ $t('info-4') }} <a class="link" @click="displayTSV=true"> {{ $t('info-5') }} </a>
        {{ $t('info-6') }}
        <a class='link' target='_blank' href='/static/carbon/travelsTemplate.tsv'> {{ $t('info-7') }} </a>.
        <br />
        {{ $t('info-8') }}
        <br /><br />
        <span v-html="$t('info-9')"></span>
      </p>
    </su-service>
    <br />
    <b-modal
      :active.sync="displayTSV"
      has-modal-card
    >
      <div class="modal-card" style="width: 920px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('info-10') }}
          </p>
        </header>
        <section class="modal-card-body">
          <travels-file-format />
        </section>
      </div>
    </b-modal>
    <b-loading :is-full-page="true" :active.sync="isLoading" :can-cancel="false">
      <b-progress :value="progressRate" size="is-large" show-value format="percent"></b-progress>
    </b-loading>
    <div class="columns">
      <div class="column">
        <b-notification
          :closable="false"
        >
          <b-field>
            <b-select expanded v-model="currentFile">
              <option v-for="(file,key) in allFiles" :key="key" :value="file.name">
                <template v-if="key !== 0">{{ $t('label-4') }} </template>
                {{ file.name }}
              </option>
            </b-select>
            <p class="control">
              <b-tooltip
                :label="$t('tooltip-1')"
                type="is-black"
                position="is-top"
              >
                <b-button
                  :disabled="submitted || travels.length === 0"
                  @click="del"
                  icon-left="trash"
                />
              </b-tooltip>
            </p>
            <p class="control">
              <b-tooltip
                :label="$t('tooltip-2')"
                type="is-black"
                position="is-top"
              >
                <b-button
                  :disabled="travelsLoadedFromDatabase || travels.length === 0"
                  @click="download"
                  icon-left="download"
                />
              </b-tooltip>
            </p>
          </b-field>
        </b-notification>
        <div class="columns">
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-1') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span>{{ nbValidTravels(currentFile) }} / {{ nbTravels(currentFile) }}</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-2') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span v-if="travels.length === 0">-</span>
                      <span v-else-if="hasPurposeOption(currentFile)">
                        <i class="sui sui-check" style="font-size:26px;color:#48c774;" /> {{ $t('yes') }}
                      </span>
                      <span v-else>
                        <i class="sui sui-times" style="font-size:26px;color:#f14668;" /> {{ $t('no') }}
                      </span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-3') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span v-if="travels.length === 0">-</span>
                      <span v-else-if="hasStatusOption(currentFile)">
                          <i class="sui sui-check" style="font-size:26px;color:#48c774;" /> {{ $t('yes') }}
                      </span>
                      <span v-else>
                        <i class="sui sui-times" style="font-size:26px;color:#f14668;" /> {{ $t('no') }}
                      </span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
        </div>
      </div>
      <div class="column is-4 is-flex is-vcentered">
        <b-upload
          :disabled="submitted"
          v-model="dropFile"
          drag-drop
          expanded
          type="is-info"
        >
          <section class="section">
            <div class="content has-text-centered">
              <p>
                <span class="icon">
                  <i style="font-size: 36px" class="sui sui-upload"></i>
                </span>
              </p>
              <p>{{ $t('info-11') }}</p>
            </div>
          </section>
        </b-upload>
      </div>
    </div>
    <br />

    <travels-table @edit="edit" />

    <b-modal
      v-if="travel!==null"
      :active.sync="displayModal"
      has-modal-card
      :can-cancel="['escape', 'x', 'outside']"
    >
      <div class="modal-card" style="width: 900px; height: auto">
        <header class="modal-card-head">
          <p v-if="modeCreation" class="modal-card-title">{{ $t('info-12') }}</p>
          <p v-else class="modal-card-title">{{ $t('info-13') }}</p>
        </header>
        <section class="modal-card-body">
          <b-notification :closable="false">
            {{ $t('info-14') }}
          </b-notification>
          <travel-form
            :travel="travel"
            :modeCreation="modeCreation"
            @close="closeModal"
            @update="update"
            @add="add"
          />
        </section>
      </div>
    </b-modal>

    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            :disabled="submitted"
            @click="displayAddForm()"
          >
            {{ $t('add') }}
          </b-button>
          <b-button
            class="level-item"
            :icon-left="validSavedIcon"
            :disabled="validerIsDisabled"
            type="is-primary"
            @click="validate()"
          >
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import axios from 'axios'
import Travel from '@/models/carbon/Travel.js'
import TravelSection from '@/models/carbon/TravelSection.js'
import { geonames } from '@/mixins/geonames'
import { travelsCSVParser } from '@/mixins/travelsCSVParser'
import { mapGetters } from 'vuex'

export default {
  name: 'Travels',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'travels-file-format': () => import('@/components/carbon/docs/TravelsFileFormat.vue'),
    'travel-form': () => import('@/components/carbon/forms/TravelForm.vue'),
    'travels-table': () => import('@/components/carbon/forms/TravelsTable.vue')
  },
  mixins: [geonames, travelsCSVParser],
  data () {
    return {
      displayTSV: false,
      dropFile: {},
      isLoading: false,
      geonamesCache: [],
      displayModal: false,
      travel: null,
      totalRequest: 0,
      processedRequests: 0,
      allFiles: [
        {
          'name': this.$t('label-5')
        }
      ],
      modeCreation: false,
      currentFile: this.$t('label-5')
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    progressRate: function () {
      return Math.round(this.processedRequests / this.totalRequest * 100)
    },
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['travelsSubmitted']
    },
    GHGIYear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    validerIsDisabled: function () {
      let toReturn = false
      if (this.module.erreur !== '') {
        toReturn = true
      } else {
        toReturn = !this.module.isModified
      }
      return toReturn
    },
    hasBeenLoaded: function () {
      let loaded = false
      if (!this.dropFile.name) {
        if (this.$store.getters['travels/hasItems'] && this.module.isValid) {
          loaded = true
        }
      }
      return loaded
    },
    travels: function () {
      return this.$store.getters['travels/items']
    },
    travelsLoadedFromDatabase: function () {
      return this.$store.getters['travels/travelsLoadedFromDatabase']
    },
    module: function () {
      return this.$store.getters['travels/module']
    }
  },
  watch: {
    dropFile: function () {
      this.processFile()
    }
  },
  methods: {
    nbValidTravels: function (source) {
      if (source === this.$t('label-5')) {
        return this.$store.getters['travels/nbValidTravels'](null)
      } else {
        return this.$store.getters['travels/nbValidTravels'](source)
      }
    },
    nbTravels: function (source) {
      if (source === this.$t('label-5')) {
        return this.$store.getters['travels/nbTravels'](null)
      } else {
        return this.$store.getters['travels/nbTravels'](source)
      }
    },
    hasPurposeOption: function (source) {
      if (source === this.$t('label-5')) {
        return this.$store.getters['travels/hasPurposeOption'](null)
      } else {
        return this.$store.getters['travels/hasPurposeOption'](source)
      }
    },
    hasStatusOption: function (source) {
      if (source === this.$t('label-5')) {
        return this.$store.getters['travels/hasStatusOption'](null)
      } else {
        return this.$store.getters['travels/hasStatusOption'](source)
      }
    },
    download: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += 'mission\tDate de départ\tVille de départ\tPays de départ\t'
      csvContent += 'Ville de destination\tPays de destination\tMode de déplacement\t'
      csvContent += 'Nb de personnes dans la voiture\tAller Retour (OUI si identiques, NON si différents)\t'
      csvContent += 'Motif du déplacement (optionnel)\tStatut de l\'agent (optionnel)\t'
      csvContent += 'distance.km\temission.kg.co2e\tuncertainty.kg.co2e\t'
      csvContent += 'emission.withcontrails.kg.co2e\tuncertainty.withcontrails.kg.co2e\n'
      for (let travel of this.travels) {
        for (let section of travel.sections) {
          let intensity = section.getCarbonIntensity(this.GHGIyear, 1)
          csvContent += travel.names.join(',') + '\t' + travel.date + '\t' + section.departureCity + '\t'
          csvContent += section.departureCountry + '\t' + section.destinationCity + '\t' + section.destinationCountry + '\t'
          csvContent += section.transportation + '\t' + section.carpooling + '\t'
          if (section.isRoundTrip) {
            csvContent += 'oui\t'
          } else {
            csvContent += 'non\t'
          }
          csvContent += travel.purpose + '\t' + travel.status + '\t'
          csvContent += parseInt(section.getFullDistance()) + '\t'
          csvContent += parseInt(intensity.intensity) + '\t' + parseInt(intensity.uncertainty) + '\t'
          csvContent += parseInt(intensity.intensitywc) + '\t' + parseInt(intensity.uncertaintywc) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5Travels_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    del: function () {
      let self = this
      let msg = this.$t('error-msg-7') + ' <strong>' + this.currentFile + '</strong> ' + this.$t('error-msg-8')
      let source = this.currentFile
      if (this.currentFile === this.allFiles[0].name) {
        msg = this.$t('error-msg-9')
        source = null
      }
      this.$buefy.dialog.confirm({
        title: self.$t('error-msg-5'),
        message: msg,
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('travels/deleteSource', source)
          self.$store.commit('travels/ISMODIFIED', true)
          if (source) {
            let index = self.allFiles.findIndex(obj => obj.name === source)
            self.allFiles.splice(index, 1)
          } else {
            self.allFiles = [
              {
                'name': self.$t('label-5')
              }
            ]
          }
          self.currentFile = self.$t('label-5')
        }
      })
    },
    closeModal: function () {
      this.displayModal = false
      this.travel = null
    },
    update: function (obj) {
      this.$store.dispatch('travels/update', obj)
      this.$store.commit('travels/ISMODIFIED', true)
      this.closeModal()
    },
    add: function (travel) {
      travel.source = 'user'
      this.$store.dispatch('travels/add', travel)
      this.$store.commit('travels/ISMODIFIED', true)
      if (this.allFiles.filter(obj => obj.name === 'user').length === 0) {
        this.allFiles.unshift({
          name: 'user'
        })
      }
      this.closeModal()
    },
    edit: function (travel) {
      this.modeCreation = false
      this.travel = travel
      this.displayModal = true
    },
    displayAddForm: function () {
      this.modeCreation = true
      let d = new Date()
      let cm = d.getMonth() + 1
      let cdate = d.getDate() + '/' + cm + '/' + d.getFullYear()
      this.travel = new Travel(
        [], cdate, [new TravelSection()], 1, null, null, 'user'
      )
      this.displayModal = true
    },
    processFile: function () {
      if (this.allFiles.filter(obj => obj.name === this.dropFile.name).length === 0) {
        let reader = new FileReader()
        let self = this
        reader.addEventListener('load', function (event) {
          let data
          try {
            data = self.parseTravels(event.target.result)
          } catch (error) {
            self.isLoading = false
            let msg = 'params' in error ? self.$t(error.message, error.params) : self.$t(error.message)
            self.$buefy.dialog.alert({
              title: self.$t('error-msg-10'),
              message: self.$t('error-msg-1') + '</br>' + msg
            })
            return
          }
          self.currentFile = self.dropFile.name

          self.processedRequests = 0
          self.$store.commit('travels/ERREUR', '')
          // first parse the file
          self.$store.commit('travels/ISMODIFIED', true)
          let travelsToSave = []
          for (let travel of data) {
            if (self.geonamesCache.filter(obj => (obj.name === travel.departureCity && obj.countryCode === travel.departureCountry)).length === 0) {
              let error = false
              if (travel.departureCountry === null || travel.departureCountry === '') {
                error = true
              }
              self.geonamesCache.unshift({
                'name': travel.departureCity,
                'countryCode': travel.departureCountry,
                'countryCodeAdded': null,
                'lat': null,
                'lng': null,
                'error': error
              })
            }
            if (self.geonamesCache.filter(obj => (obj.name === travel.destinationCity && obj.countryCode === travel.destinationCountry)).length === 0) {
              let error = false
              if (travel.destinationCountry === null || travel.destinationCountry === '') {
                error = true
              }
              self.geonamesCache.unshift({
                'name': travel.destinationCity,
                'countryCode': travel.destinationCountry,
                'countryCodeAdded': null,
                'lat': null,
                'lng': null,
                'error': error
              })
            }
            travelsToSave.push(travel)
          }
          // build a request for all cities not in memory
          let allRequests = []
          let icities = []
          let index = 0
          for (let city of self.geonamesCache) {
            if (city.lat === null || city.lng === null) {
              allRequests.unshift(self.searchGEONames(city.name, city.countryCode, 1, 1, true))
              icities.unshift(index)
            }
            index += 1
          }
          self.totalRequest = allRequests.length
          axios.all(allRequests)
            .then(axios.spread((...responses) => {
              // update the memory
              let index = 0
              for (let icity of icities) {
                try {
                  if (!self.geonamesCache[icity]['error']) {
                    self.geonamesCache[icity]['lat'] = responses[index].data.geonames[0].lat
                    self.geonamesCache[icity]['lng'] = responses[index].data.geonames[0].lng
                    self.geonamesCache[icity]['countryCodeAdded'] = responses[index].data.geonames[0].countryCode
                  }
                } catch {
                  self.geonamesCache[icity]['error'] = true
                  if ('status' in responses[index].data) {
                    if (responses[index].data.status.value === 19) {
                      self.$store.commit('travels/ERREUR', self.$t('error-msg-2'))
                    }
                  }
                }
                index += 1
              }
              // update travels
              for (let travel of travelsToSave) {
                let cDeparture = self.geonamesCache.filter(obj => (obj.name === travel.departureCity && obj.countryCode === travel.departureCountry))[0]
                let cDestination = self.geonamesCache.filter(obj => (obj.name === travel.destinationCity && obj.countryCode === travel.destinationCountry))[0]
                if (travel.departureCountry === null) {
                  travel.departureCountry = cDeparture['countryCodeAdded']
                }
                if (travel.destinationCountry === null) {
                  travel.destinationCountry = cDestination['countryCodeAdded']
                }
                self.$store.dispatch('travels/addFromFile', {
                  'names': travel.names,
                  'date': travel.date,
                  'purpose': travel.purpose,
                  'status': travel.status,
                  'amount': 1,
                  'sections': [{
                    'type': travel.type,
                    'isRoundTrip': travel.isRoundTrip,
                    'departureCity': travel.departureCity,
                    'departureCountry': travel.departureCountry,
                    'destinationCity': travel.destinationCity,
                    'destinationCountry': travel.destinationCountry,
                    'transportation': travel.transportation,
                    'carpooling': travel.carpooling,
                    'departureCityLat': cDeparture['lat'],
                    'departureCityLng': cDeparture['lng'],
                    'destinationCityLat': cDestination['lat'],
                    'destinationCityLng': cDestination['lng'],
                    'distance': travel.distance
                  }],
                  'source': self.dropFile.name
                })
              }
              self.$store.dispatch('travels/sortSections')
              self.allFiles.push({
                name: self.dropFile.name
              })
              self.isLoading = false
            }))
        })
        reader.onloadstart = (ev) => {
          self.isLoading = true
        }
        reader.onerror = (ev) => {
          self.isLoading = false
          self.$store.commit('travels/ERREUR', ev.target.error)
        }
        reader.readAsText(this.dropFile)
      } else {
        let self = this
        this.$buefy.dialog.confirm({
          title: self.$t('error-msg-3'),
          message: self.$t('error-msg-4'),
          confirmText: self.$t('validate'),
          cancelText: self.$t('cancel'),
          canCancel: false
        })
      }
    },
    validate: function () {
      let self = this
      if (this.$store.getters['travels/invalidTravels'].length !== 0) {
        this.$buefy.dialog.confirm({
          title: self.$t('error-msg-5'),
          message: self.$t('error-msg-6'),
          confirmText: self.$t('validate'),
          cancelText: self.$t('cancel'),
          canCancel: ['escape', 'button', 'outside'],
          onConfirm: function () {
            self.$store.dispatch('travels/deleteInvalid')
            self.subValidate()
          }
        })
      } else {
        this.subValidate()
      }
    },
    subValidate: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('travels/save')
          .then(data => {
            loadingComponent.close()
            if (this.travels.length === 0) {
              this.$store.commit('travels/ISVALID', false)
            } else {
              this.$store.commit('travels/ISVALID', true)
            }
            this.$store.commit('travels/ERREUR', '')
            this.$store.commit('travels/ISMODIFIED', false)
            this.allFiles = [
              {
                'name': this.$t('label-5')
              }
            ]
            this.currentFile = this.$t('label-5')
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg')
            })
          })
          .catch((error) => {
            loadingComponent.close()
            this.$store.commit('travels/ISVALID', false)
            this.$store.commit('travels/ERREUR', error.response.data)
          })
      } else {
        if (this.travels.length === 0) {
          this.$store.commit('travels/ISVALID', false)
        } else {
          this.$store.commit('travels/ISVALID', true)
        }
        this.$store.commit('travels/ISMODIFIED', false)
      }
    }
  }
}
</script>

<style lang="css">
tr.is-warning {
  background: #fff1f1 !important;
  color: rgba(0, 0, 0, 0.7) !important;
}
</style>
